



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>使用JavaScript实现新闻滚动效果</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">使用JavaScript实现新闻滚动效果</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-14 00:57:23 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>最近要实现一个滚动新闻效果，在网上查了一些资料，发现基本的实现方法有两种：</p>
<ol><li>使用Marquee标签。这个标签的使用我已经转载了一篇比较详细的文章，这个标签的优点是便于使用，缺点是人们已经逐渐不适用它了，许多浏览器不支持，甚至在IE8想，XHTML4.0的loose.dtd是可以的，而去掉loose.dtd却不行。</li>
<li>使用div+javascript的方法。这种方法的好处是可以兼容几乎所有的浏览器，并且在可以预料的时间内仍能稳定运行。并且使用div使得网页可以利用现有的css资源实现很多炫目的效果。缺点是需要一定的编程经验和耐心。</li></ol>
<p>使用javascript+div方式的基本原理是一样的，利用scrollTop属性和offsetheight属性来实现移动效果。一般使用两个div，里面的内容是一样的，然后利用两个div拼接，形成不断循环的效果。</p>
<div>
<pre class="prettyprint linenums">&lt;html&gt;<br />
&lt;head&gt;<br />
&lt;meta http-equiv="Content-Type" content="text/html; charset=UTF-8"&gt;<br />
&lt;title&gt;Insert title here&lt;/title&gt;<br />
&lt;script type="text/javascript"&gt;<br />
    var layerHeight = 100; //定义滚动区域的高度：100<br />
    var iFrame = 1; //定义每帧移动的象素<br />
    var iFrequency = 50; //定义帧频率<br />
    var timer; //定义时间句柄

    //滚动新闻动作，相当于拖动layer1滚动条向下滚动，实现新闻滚动效果<br />
    function move()<br />
    {<br />
       if(document.getElementById("layer1").scrollTop &gt;= document.getElementById("layer2").offsetHeight)//如果拖动完div2中的新闻，重置滚动条位置<br />
       {<br />
           document.getElementById("layer1").scrollTop -= (document.getElementById("layer2").offsetHeight - iFrame);<br />
       }<br />
       else<br />
       {<br />
           //效果等同于向下拖动layer1的滚动条，形成新闻滚动效果<br />
           document.getElementById("layer1").scrollTop += iFrame;<br />
       }<br />
   }  

            window.onload=function()<br />
            {<br />
                  //设置layer1高度<br />
                  if(document.getElementById("layer2").offsetHeight &gt;= layerHeight)<br />
                  {<br />
                       document.getElementById("layer1").style.height = layerHeight;<br />
                  }<br />
                  else<br />
                  {<br />
                       document.getElementById("layer1").style.height = document.getElementById("layer2").offsetHeight;<br />
                  }

                  //将layer2中的内容复制到layer3，用两个div实现新闻循环滚动效果<br />
                  document.getElementById("layer3").innerHTML = document.getElementById("layer2").innerHTML; 

                  //开始滚动新闻<br />
                  timer = setInterval("move()",iFrequency);  

                  //当鼠标移上去时，停止滚动<br />
                  document.getElementById("layer1").onmouseover=function() {clearInterval(timer);}<br />
                  document.getElementById("layer1").onmouseout=function() {timer=setInterval("move()",iFrequency);}<br />
            }<br />
&lt;/script&gt;<br />
&lt;/head&gt;<br />
&lt;body&gt;<br />
&lt;div id='layer1' style="overflow-y:hidden;"&gt;<br />
   &lt;div id='layer2'&gt;<br />
             &lt;table cellspacing="0" cellpadding="0" border="0" width="63"&gt;<br />
                        &lt;tr&gt;<br />
                            &lt;td height="10"/&gt;aaaaaaaaaa&lt;/td&gt;<br />
                        &lt;/tr&gt;<br />
                        &lt;tr&gt;<br />
                            &lt;td height="10"/&gt;bbbbbbbbbb&lt;/td&gt;<br />
                        &lt;/tr&gt;<br />
                         &lt;tr&gt;<br />
                            &lt;td height="10"/&gt;cccccccccc&lt;/td&gt;<br />
                        &lt;/tr&gt;<br />
              &lt;/table&gt;<br />
        &lt;/div&gt;<br />
        &lt;div id='layer3'&gt;&lt;/div&gt;<br />
    &lt;/div&gt;<br />
&lt;/body&gt;<br />
&lt;/html&gt;</pre>
</div>
<p>转载自<a href="http://blog.csdn.net/jubincn/article/details/4689337" rel="external nofollow noreferrer">http://blog.csdn.net/jubincn/article/details/4689337</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvvyyqx.html">探究&commat;property申明对象属性时copy与strong的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8km0479.html">Sublime Text 2 实用快捷键（Mac OS X）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m967zmn8.html">PO VO BO DTO POJO DAO&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mpko68.html">Python经典资料汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mp5y68.html">转载：CDH5&period;X完全卸载步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4kgw09.html">How to upgrade Subversion on OSX</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rm3248.html">mysql错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m62g29.html">CNN初步-1</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ek02j8.html">iPhone6手機產品提交了進網申請</a>
		</li>
						<li><a href="https://www.batexi.com/a/495odg08.html">&lbrack;C&num;&rsqb; zdbviewcs&colon; 跨平台数据库查看器。支持SqlServer、Oracle、MySql等数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k76z39.html">&lbrack;转载&rsqb;堆排序（HeapSort） Java实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wj7llq.html">在VS 2015 RTM 版中 提示 未能正确加载 NuGetPackage包</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1v0gx8.html">并发编程之二：wait、notify、notifyAll的使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdr53k8.html">混乱的url编码&vert;&vert;URL编码解码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjoyvk9.html">论C&plus;&plus;与三国</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j05j3lq.html">关于bootstrap--表单（按钮&amp;lt&semi;button&amp;gt&semi;效果、大小、禁用）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yxjg5q.html">svm中的数学和算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vonkm8.html">在JavaScript的数组中进行数组元素查找和替换&lpar;JS的indexOf等&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljly119.html">【驱动】USB驱动&amp;&num;183&semi;入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1755jq.html">P1373 小a和uim之大逃离</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rd5ze78.html">curl命令使用大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xgr5v8.html">【转】PHP中require和include路径问题总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydy1ljq.html">解决Navicat无法连接Oracle的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjwd5k9.html">简单了解ddos攻击</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv214xq.html">Java中的定时器Timer</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e144le9.html">用HTML5构建一个流程图绘制工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv2dlyq.html">错误：javax&period;servlet&period;jsp&period;PageContext can not be to a type</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xgmpv8.html">Redis介绍及实践分享</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydy4mmq.html">WIN 8&period;1 x64 环境下 COM Surrogate 停止工作解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vred48.html">NOIP第7场模拟赛题解</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
